﻿function Liquid_Wealth:GetGuildBankTabVaule(TabID)
	local TabAuctionValue=0;
	local TabVenderValue=0;
	local name, icon, isViewable, _, _, _ = GetGuildBankTabInfo(TabID)

	if GuildBankFrame and GuildBankFrame:IsVisible() then
		for slot = 1, 98 do
			if GetGuildBankItemLink(TabID, slot) then
				local texture, itemCount, locked = GetGuildBankItemInfo(TabID,slot)
				local ItemLink = GetGuildBankItemLink(TabID,slot)
				local itemsPrice=0;
				itemsPrice=Liquid_Wealth:GetItemValueAuction(ItemLink)
				TabAuctionValue = TabAuctionValue + floor(itemCount*itemsPrice);
				itemsPrice=Liquid_Wealth:GetItemValueVender(ItemLink)
				TabVenderValue = TabVenderValue + floor(itemCount*itemsPrice);
			end
		end
	end

	return TabAuctionValue, TabVenderValue;
end

function Liquid_Wealth:ScanGuildBank()
	for tabIndex = 1, GetNumGuildBankTabs() do
	  --print("scaning tab: "..tabIndex)
		local name, icon, isViewable,_,_,_ = GetGuildBankTabInfo(tabIndex)
		guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");

		local TabAuctionValue, TabVenderValue = Liquid_Wealth:GetGuildBankTabVaule(tabIndex)
		Liquid_Wealth.db.realm.guild[guildName][tabIndex] = Liquid_Wealth:CovGuildBankItemDataToDB(name,icon,isViewable,TabVenderValue,TabAuctionValue)
		if not GetGuildBankItemLink(tabIndex, 1) then
			tinsert(tabsNotScanned, name)
		end
	end
end


function Liquid_Wealth:CheckGuildBankRank(guildName,tabIndex,currentRank)
	local isViewableRank = false
	local isRankInTable = false
	local tbl = {}
	_,_,isViewable,_,_= Liquid_Wealth:CovGuildBankItemDataFromDB(guildName,tabIndex) --Gets the current tab from database
	if not isViewable == nil then
		local tbl = { strsplit("|", isViewable) } --strip ACL list
	end
	for _,rank in pairs(tbl) do
		if rank == currentRank then --Loop though ACL list to see if current login toon has the rank listed in the list if true set boolen true
			isRankInTable = true
		end
	end
	if not isRankInTable then
		tinsert(tbl, currentRank) -- If loop returns false add the current rank to the table
	end
	local _,min = maxmin(t) -- get the min from table
	if (min <= currentRank) and not isRankInTable then
		isViewableRank = true
	elseif isRankInTable then
		isViewableRank = true
	end
	return isViewableRank
end


function maxmin(t)
  local max = -math.huge
  local min = math.huge

  for k,v in pairs( t ) do
    if type(v) == 'number' then
      max = math.max( max, v )
      min = math.min( min, v )
    end
  end

  return max, min
end

--function min (a, ...)
  -- for n in values{...} do if n<a then a=n end end
  -- return a
-- end


-- function Liquid_Wealth:ScanGuildBank(GuildName)
	-- for banktab = 1, GetNumGuildBankTabs() do
		-- local name, icon, isViewable,_,_,_ = GetGuildBankTabInfo(banktab)
		-- if ((not isViewable) and (not Liquid_Wealth.db.realm.guild[GuildName][banktab]))  then -- Need to put in error checking on toons that cant see the guild bank, i dont want to rewrite the data

		-- elseif (isViewable) then
			-- local TabAuctionValue, TabVenderValue = Liquid_Wealth:GetGuildBankTabVaule(banktab)
			-- Liquid_Wealth.db.realm.guild[GuildName][banktab] = Liquid_Wealth:CovGuildBankItemDataToDB(name,icon,isViewable,TabVenderValue,TabAuctionValue)
			-- if not GetGuildBankItemLink(banktab, 1) then
				-- tinsert(tabsNotScanned, name)
			-- end
		-- end
	-- end
-- end


